class Booking_App_Calendar {
	
	constructor(weekName, dateFormat, positionOfWeek, i18n){
	    
	    this._i18n = null;
	    if(typeof i18n == 'object'){
	        
	        console.log(typeof i18n);
	        this._i18n = i18n;
	        
	    }
		
		this.setWeekNameList(weekName);
		if(dateFormat != null){
		    
		    this._dateFormat = dateFormat;
		    
		}else{
		    
		    this._dateFormat = 0;
		    
		}
		
		if(positionOfWeek == null){
		    
		    this._positionOfWeek = "before";
		    
		}else{
		    
		    this._positionOfWeek = positionOfWeek;
		    
		}
		
		this._shortWeekNameBool = false;
		
		console.log("this._positionOfWeek = " + this._positionOfWeek);
		
	}
	
	setShortWeekNameBool(bool){
	    
	    this._shortWeekNameBool = bool;
	    
	}
	
	setWeekNameList(weekName){
	    
	    this._weekName = weekName;
	    
	}
	
	getWeekNameList(){
	    
	    return this._weekName;
	    
	}
	
	create(calendarPanel, calendarData, month, day, year, permission, callback){
	    
	    var dayHeight = parseInt(calendarPanel.clientWidth / 7);
	    console.log("dayHeight = " + dayHeight);
	    
	    var weekNamePanel = document.createElement("div");
	    weekNamePanel.setAttribute("class", "calendar");
	    var weekName = this.getWeekNameList();
	    for(var i = 0; i < 7; i++){
	  	
            var dayPanel = document.createElement("div");
            dayPanel.setAttribute("class", "dayPanel");
            dayPanel.textContent = weekName[i];
            weekNamePanel.insertAdjacentElement("beforeend", dayPanel);
            if(i == 6){
                
                dayPanel.setAttribute("style", "border-width: 1px 1px 0px 1px;")
	            
            }
        }
        
	    calendarPanel.insertAdjacentElement("beforeend", weekNamePanel);
        
        var lastDay = parseInt(calendarData['date']['lastDay']);
        var startWeek = parseInt(calendarData['date']['startWeek']);
        var lastWeek = parseInt(calendarData['date']['lastWeek']);
        
        var weekCount = 0;
        var calendar = calendarData.calendar;
        var scheduleList = calendarData.schedule;
        
        var weekLine = Object.keys(calendar).length / 7;
        console.log(calendarData);
        console.log("weekLine = " + weekLine);
        for(var key in calendar){
            
            //console.log(calendar[key]);
            var className = 'dayPanel dayPanelHeight';
            var dataKey = parseInt(calendar[key].year + ("0" + calendar[key].month).slice(-2) + ("0" + calendar[key].day).slice(-2));
            //console.log("dataKey = " + dataKey);
            var bool = 1;
            
            var textPanel = document.createElement("div");
            textPanel.setAttribute("class", "dayPostion");
            textPanel.textContent = calendar[key].day;
            
            var dayPanel = document.createElement("div");
            dayPanel.setAttribute("data-day", calendar[key].day);
            dayPanel.setAttribute("data-month", calendar[key].month);
            dayPanel.setAttribute("data-year", calendar[key].year);
            dayPanel.setAttribute("data-key", key);
            dayPanel.setAttribute("data-week", weekCount);
            dayPanel.setAttribute("class", className);
            dayPanel.insertAdjacentElement("beforeend", textPanel);
            weekNamePanel.insertAdjacentElement("beforeend", dayPanel);
            
            var data = {key: dataKey, month: calendar[key].month, day: calendar[key].day, year: calendar[key].year, eventPanel: dayPanel, status: true, count: i, bool: bool};
            
            if(calendar[dataKey].status != null){
                
                data.status = calendar[dataKey].status;
                
            }
            
            if(scheduleList != null){
                
                (function(data, schedule){
                    
                    var capacity = 0;
                    var remainder = 0;
                    for(var key in schedule){
                        
                        capacity += parseInt(schedule[key].capacity);
                        remainder += parseInt(schedule[key].remainder);
                        
                    }
                    
                    data.capacity = capacity;
                    data.remainder = remainder;
                    
                })(data, scheduleList[key]);
                
            }
            
            //console.log(data);
            if(calendarData.calendar[dataKey] != null || (calendarData.reservation != null && calendarData.reservation[dataKey])){
                
                dayPanel.setAttribute("class", "dayPanel dayPanelHeight pointer");
                
                if(parseInt(weekLine) == 1){
                    
                    dayPanel.setAttribute("class", "border_bottom_width dayPanel dayPanelHeight pointer");
                    
                }
                
                data.status = true;
                if(calendar[dataKey].status != null){
                    
                    data.status = calendar[dataKey].status;
                    
                }
                callback(data);
                
            }else{
                
                dayPanel.setAttribute("class", "dayPanel dayPanelHeight closeDay");
                
                if(parseInt(weekLine) == 1){
                    
                    dayPanel.setAttribute("class", "border_bottom_width dayPanel dayPanelHeight closeDay");
                    
                }
                
                data.status = false;
                if(calendar[dataKey].status != null){
                    
                    data.status = calendar[dataKey].status;
                    
                }
                callback(data);
                
            }
            
            if(weekCount == 6){
                
                //dayPanel.setAttribute("style", "border-width: 1px 1px 0px 1px; height: " + dayHeight + "px;");
                var style = dayPanel.getAttribute("style");
                if(style == null){
                    
                    style = "";
                    
                }
                dayPanel.setAttribute("style", style + "border-width: 1px 1px 0px 1px;");
                
            }
            
            if(weekCount == 6){
                	
                weekCount = 0;
                weekLine--;
                
            }else{
                
                weekCount++;
                
            }
            
        }
        
        return true;
        
    }
    
    getExpressionsCheck(expressionsCheck){
        
        var i18n = this._i18n;
        var response = {
            arrival: i18n.get("Arrival (Check-in)"), 
            chooseArrival: i18n.get("Please choose %s", [i18n.get("Arrival (Check-in)")]),
            departure: i18n.get("Departure (Check-out)"),
            chooseDeparture: i18n.get("Please choose %s", [i18n.get("Departure (Check-out)")]),
        
        };
        if(expressionsCheck == 1){
            
            response.arrival = i18n.get("Arrival");
            response.departure = i18n.get("Departure");
            response.chooseArrival = i18n.get("Please choose %s", [response.arrival]);
            response.chooseDeparture = i18n.get("Please choose %s", [response.departure]);
            
        }else if(expressionsCheck == 2){
            
            response.arrival = i18n.get("Check-in");
            response.departure = i18n.get("Check-out");
            response.chooseArrival = i18n.get("Please choose %s", [response.arrival]);
            response.chooseDeparture = i18n.get("Please choose %s", [response.departure]);
            
        }
        
        return response;
        
    }
    
    getDateKey(month, day, year){
        
        var key = year + ("0" + month).slice(-2) + ("0" + day).slice(-2);
        return key;
        
    }
	
	formatBookingDate(month, day, year, hour, min, title, week){
        
        var i18n = this._i18n;
        var dateFormat = this._dateFormat;
        console.log("dateFormat = " + dateFormat + " month = " + month + " day = " + day + " year = " + year + " hour = " + hour + " min = " + min + " week = " + week);
        if(month != null){
            
            month = ("0" + month).slice(-2);
            
        }
        
        if(day != null){
            
            day = ("0" + day).slice(-2);
            
        }
        
        if(hour != null){
            
            hour = ("0" + hour).slice(-2);
            
        }
        
        if(min != null){
            
            min = ("0" + min).slice(-2);
            
        }
        
        if(week != null){
            
            week = parseInt(week);
            
        }
        
        if(month != null && day == null && year == null){
            
            date = month;
            if(dateFormat == 2 || dateFormat == 5){
                
                var monthShortName = ['', i18n.get('Jan'), i18n.get('Feb'), i18n.get('Mar'), i18n.get('Apr'), i18n.get('May'), i18n.get('Jun'), i18n.get('Jul'), i18n.get('Aug'), i18n.get('Sep'), i18n.get('Oct'), i18n.get('Nov'), i18n.get('Dec')];
                date = monthShortName[parseInt(month)];
                
            }
            return date;
            
        }
        
        //var weekName = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
        var weekName = [i18n.get('Sunday'), i18n.get('Monday'), i18n.get('Tuesday'), i18n.get('Wednesday'), i18n.get('Thursday'), i18n.get('Friday'), i18n.get('Saturday')];
        //weekName = this._weekName;
        if(this._shortWeekNameBool == true){
            
            weekName = [i18n.get('Sun'), i18n.get('Mon'), i18n.get('Tue'), i18n.get('Wed'), i18n.get('Thu'), i18n.get('Fri'), i18n.get('Sat')];
            
        }
        var monthFullName = ['', i18n.get('January'), i18n.get('February'), i18n.get('March'), i18n.get('April'), i18n.get('May'), i18n.get('June'), i18n.get('July'), i18n.get('August'), i18n.get('September'), i18n.get('October'), i18n.get('November'), i18n.get('December')];
        var date = monthFullName[parseInt(month)] + " " + day + ", " + year + " ";
        
        if(dateFormat == 0){
            
            date = month + "/" + day + "/" + year + " ";
            if(day == null){
                
                date = month + "/" + year;
                
            }
            
        }else if(dateFormat == 1){
            
            date = month + "-" + day + "-" + year + " ";
            if(day == null){
                
                date = month + "-" + year;
                
            }
            
        }else if(dateFormat == 2){
            
            date = monthFullName[parseInt(month)] + " " + day + ", " + year + " ";
            if(day == null){
                
                date = monthFullName[parseInt(month)] + "," + year;
                
            }
            
        }else if(dateFormat == 3){
            
            date = day + "/" + month + "/" + year + " ";
            if(day == null){
                
                date = month + "/" + year;
                
            }
            
        }else if(dateFormat == 4){
            
            date = day + "-" + month + "-" + year + " ";
            if(day == null){
                
                date = month + "-" + year;
                
            }
            
        }else if(dateFormat == 5){
            
            date = day + " " + monthFullName[parseInt(month)] + ", " + year + " ";
            if(day == null){
                
                date = monthFullName[parseInt(month)] + ", " + year;
                
            }
            
        }else if(dateFormat == 6){
            
            date = year + "/" + month + "/" + day + " ";
            if(day == null){
                
                date = month + "/" + year;
                
            }
            
        }else if(dateFormat == 7){
            
            date = year + "-" + month + "-" + day + " ";
            if(day == null){
                
                date = month + "-" + year;
                
            }
            
        }else{
            
        }
        
        if(month == null && day != null && year == null){
            
            date = day;
            
        }
        
        if(this._positionOfWeek == 'before'){
            
            if(dateFormat != 2 && week != null){
                
                date = this._i18n.get(weekName[week]) + " " + date;
                
            }else if(dateFormat == 2 && week != null){
                
                date = this._i18n.get(weekName[week]) + ", " + date;
                
            }
            
        }else{
            
            if(dateFormat != 2 && week != null){
                
                date = date + " " + this._i18n.get(weekName[week]) + " ";
                
            }else if(dateFormat == 2 && week != null){
                
                date = date + ", " + this._i18n.get(weekName[week]) + " ";
                
            }
            
        }
        
        
        
        if(hour != null && min != null){
            date += hour + ":" + min + " ";
        }
        
        if(title != null){
            date += title;
        }
        
        return date;
        
    }
	
}