<?php
    
    if(!defined('ABSPATH')){
    	exit;
	}
	
    class CreditCard {
    
	    public $response = array();
	    
	    public $pluginName = null;
        
	    public $lang = null;
        
	    public function __construct($pluginName){
		    
		    $this->pluginName = $pluginName;
		    
	    }
        
	    public function pay($payId, $secret, $token, $amont, $currency, $key, $name){
            
            $response = array('error' => "8001");
		    if($payId == 'stripe'){
                
			    $response = $this->commitStripe($payId, $secret, $token, $amont, $currency, $key, $name);
                
		    }
            
            $this->response = $response;
	        return $response;
            
        }
        
        public function cancel($payId, $secret, $chargeId){
            
            $response = array('error' => "8002");
            if($payId == 'stripe'){
                $response = $this->cancelStripe($payId, $secret, $chargeId);
            }
            
            $this->response = $response;
	        return $response;
            
        }
        
        public function commitStripe($payId, $secret, $token, $amont, $currency, $key, $name){
            
            $message = array();
            $params = array('source' => $token, 'amount' => $amont, 'currency' => $currency, 'description' => "ID: ".$key." Name: ".$name);
            $response = null;
            
            $ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, "https://api.stripe.com/v1/charges");
			curl_setopt($ch, CURLOPT_USERPWD, $secret.":");
			curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($params));
			curl_setopt($ch, CURLOPT_POST, 1);
			
			ob_start();
			$response = curl_exec($ch);
			$response = ob_get_contents();
			ob_end_clean();
			$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close ($ch);
            
            $response = json_decode($response, true);
            #var_dump($response);
            
            if($httpCode < 400){
                
                if(isset($response['id']) && $response['status'] == 'succeeded'){
                    
                    $message['cardToken'] = $response['id'];
                    
                }else{
                    
                    if($httpCode == 400){
                        
                        $message['error'] = __("The request was unacceptable, often due to missing a required parameter.", $this->pluginName);
                        
                    }else if($httpCode == 401){
                        
                        $message['error'] = __("No valid API key provided.", $this->pluginName);
                        
                    }else if($httpCode == 402){
                        
                        $message['error'] = __("The parameters were valid but the request failed.", $this->pluginName);
                        
                    }else if($httpCode == 404){
                        
                        $message['error'] = __("The requested resource doesn't exist.", $this->pluginName);
                        
                    }else if($httpCode == 409){
                        
                        $message['error'] = __("The request conflicts with another request (perhaps due to using the same idempotent key).", $this->pluginName);
                        
                    }else if($httpCode == 429){
                        
                        $message['error'] = __("Too many requests hit the API too quickly. We recommend an exponential backoff of your requests.", $this->pluginName);
                        
                    }else if($httpCode == 500 || $httpCode == 502 || $httpCode == 503 || $httpCode == 504){
                        
                        $message['error'] = __("Something went wrong on Stripe's end.", $this->pluginName);
                        
                    }else{
                        
                        $message['error'] = __("8007", $this->pluginName);
                        
                    }
                
                }
            
            }else{
                
                $message = $this->httpCodeError($httpCode, $payId);
                
            }
            
            return $message;
            
        }
        
        public function commitPayPal($payId, $secret, $token, $amont, $currency, $key, $name){
            
            $message = array();
            $bool = $this->payPalInclude();
            if($bool == true){
                
                $request = array('amount' => $amont, 'merchantAccountId' => $currency, 'paymentMethodNonce' => $token, 'orderId' => $key, 'options' => array('submitForSettlement' => true));
                $gateway = new Braintree_Gateway(array('accessToken' => $secret));
                $result = $gateway->transaction()->sale($request);
                if($result->success === true){
                    
                    $message['cardToken'] = $result->transaction->id;
                    $message['paymentId'] = $result->transaction->paypalDetails->paymentId;
                    $message['payerId'] = $result->transaction->paypalDetails->payerId;
                    
                }else{
                    
                    $message['error'] = $result->message;
                    
                }
                
                return $message;
                
            }else{
                
                return array('error' => "8020");
                
            }
            
        }
        
        public function cancelStripe($payId, $secret, $chargeId){
            
            $url = "https://api.stripe.com/v1/refunds";
            $message = array();
            $params = array('charge' => $chargeId);
            $response = null;
            
            $ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_USERPWD, $secret.":");
			curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($params));
			curl_setopt($ch, CURLOPT_POST, 1);
			
			ob_start();
			$response = curl_exec($ch);
			$response = ob_get_contents();
			ob_end_clean();
			$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close ($ch);
            
            $response = json_decode($response, true);
            if($httpCode < 400){
                
                if(isset($response['id']) && $response['status'] == 'succeeded'){
                    
                    $message['cardToken'] = $response['id'];
                    
                }
                	
            }else{
                
                $message = $this->httpCodeError($httpCode, $payId);
                
            }
            
            return $message;
            
        }
        
        public function cancelPayPal($payId, $secret, $chargeId){
            
            $message = array();
            $bool = $this->payPalInclude();
            if($bool == true){
                
                $gateway = new Braintree_Gateway(array('accessToken' => $secret));
                $result = $gateway->transaction()->refund($chargeId);
                if($result->success === true){
                    
                    $message['cardToken'] = $result->transaction->id;
                    
                }else{
                    
                    $message['error'] = $result->message;
                    
                }
                
                return $message;
                
            }else{
                
                return array('error' => "8020");
                
            }
            
        }
        
        public function httpCodeError($httpCode, $payId){
            
            $message = array();
            if($httpCode == 400){
                $message['error'] = __("The request was unacceptable, often due to missing a required parameter.", $this->pluginName);
            }else if($httpCode == 401){
                $message['error'] = __("No valid API key provided.", $this->pluginName);
            }else if($httpCode == 402){
                $message['error'] = __("The parameters were valid but the request failed.", $this->pluginName);
            }else if($httpCode == 404){
                $message['error'] = __("The requested resource doesn't exist.", $this->pluginName);
            }else if($httpCode == 409){
                $message['error'] = __("The request conflicts with another request (perhaps due to using the same idempotent key).", $this->pluginName);
            }else if($httpCode == 429){
                $message['error'] = __("Too many requests hit the API too quickly. We recommend an exponential backoff of your requests.", $this->pluginName);
            }else{
                $message['error'] = __("Something went wrong on Stripe's end.", $this->pluginName);
            }
            
            return $message;
            
        }
        
    }

?>